/* dm6000End.c - dm6000 END  network interface driver */
/* Copyright Reserevd all by Davicom Semiconductor CO.,LTD */
/* version 1.0     				           */
#include "copyright_wrs.h"

#include "vxWorks.h"
#include "endLib.h"			/* Common END structures. */
#include "end.h"
#include "etherLib.h"
#include "etherMultiLib.h"
#include "netLib.h"
#include "cacheLib.h"
#include "lstLib.h"			/* Needed to maintain protocol list. */
#include "iv.h"
#include "stdlib.h"
#include "sysLib.h"
#include "intLib.h"
#include "taskLib.h"
#define	INT_NUM_IRQ0		0xe0	/* vector number for IRQ0 */
     



IMPORT  int endMultiLstCnt (END_OBJ* pEnd);
/*#define printf      SysDebugPrint*/

#define EEmyMAC             0x00
#define EEmyIP              0x30
#define EEhostIP            0x34

/* defines */
#define UCHAR               unsigned char
#define UWORD               unsigned short int

#define DM6000_REG00        0x00
#define DM6000_REG05        0x30    /* SKIP_CRC/SKIP_LONG whz modify*/ 
#define DM6000_REG08        0x27   /*old =0x3f */
#define DM6000_REG09        0x38
#define DM6000_REG0A        0x08
#define DM6000_REGFF        0x83    /*0x8F     IMR */

#define DM6000_PHY          0x40    /* PHY address 0x01 */
#define DM6000_PKT_MAX      1536    /* Received packet max size */
#define DM6000_PKT_RDY      0x01    /* Packet ready to receive */
#define DM6000_MIN_IO       0x300
#define DM6000_MAX_IO       0x370
#define DM6000_INT_MII      0x00
#define DM6000_EXT_MII      0x80

#define DM6000_10MHD        0
#define DM6000_100MHD       1
#define DM6000_10MFD        4
#define DM6000_100MFD       5
#define DM6000_AUTO         8
#define DM6000_1M_HPNA      0x10

#define DM6000_MEDIA_MODE   DM6000_AUTO

#define FASTETHER_NIC       0
#define HOMERUN_NIC         1
#define LONGRUN_NIC         2

#define DM9801_NOISE_FLOOR  0x08
#define DM9802_NOISE_FLOOR  0x05

#define DM6000_DEV_NAME     "dm"
#define DM6000_DEV_NAME_LEN 3

/* Configuration items */

#define END_BUFSIZ      (ETHERMTU + ENET_HDR_REAL_SIZ + 6)
#define EH_SIZE         (14)
#define END_SPEED_10M   10000000    /* 10Mbs */
#define END_SPEED_100M  100000000   /* 100Mbs */
#define END_SPEED       END_SPEED_10M


#undef htons
#define htons(x)  ((((x)&0xff00)>>8)|((x)&0x00ff)<<8)

/* Cache macros */

#define END_CACHE_INVALIDATE(address, len) \
        CACHE_DRV_INVALIDATE (&pDrvCtrl->cacheFuncs, (address), (len))

#define END_CACHE_PHYS_TO_VIRT(address) \
        CACHE_DRV_PHYS_TO_VIRT (&pDrvCtrl->cacheFuncs, (address))

#define END_CACHE_VIRT_TO_PHYS(address) \
        CACHE_DRV_VIRT_TO_PHYS (&pDrvCtrl->cacheFuncs, (address))

/*
 * Default macro definitions for BSP interface.
 * These macros can be redefined in a wrapper file, to generate
 * a new module with an optimized interface.
 */

/* Macro to connect interrupt handler to vector */

#ifndef SYS_INT_CONNECT
#define SYS_INT_CONNECT(pDrvCtrl,rtn,arg,pResult) \
	{ \
    IMPORT STATUS sysIntConnect();  \
	*pResult = intConnect ((VOIDFUNCPTR *)0x118, \
			     rtn, (int)arg); \
	}
#endif

/* Macro to disconnect interrupt handler from vector */

#ifndef SYS_INT_DISCONNECT
#define SYS_INT_DISCONNECT(pDrvCtrl,rtn,pResult) \
	{ \
   *pResult = OK; /* HELP: need a real routine */ \
   }
#endif

/* Macro to enable the appropriate interrupt level */

/*#ifndef SYS_INT_ENABLE
#define SYS_INT_ENABLE(pDrvCtrl) \
	{ \
	IMPORT void sysLanIntEnable(); \
	sysLanIntEnable (pDrvCtrl->ilevel); \
	}
#endif*/

/* Macro to get the ethernet address from the BSP */


/*
 * Macros to do a short (UINT16) access to the chip. Default
 * assumes a normal memory mapped device.
 */
    #define DM6000_IOADDR       0x300
    #define DM6000_IODATA       0x304

#ifndef DM6000_OUT_CHAR
#define DM6000_OUT_CHAR(addr,value)\
    { \
    sysOutByte( DM6000_IOADDR,addr);\
    sysOutByte( DM6000_IODATA,value);\
    }
#endif
/*void DM6000_OUT_CHAR(unsidned long addr,UCHAR value)
{
	sysOutByte( DM6000_IOADDR,addr);
    sysOutByte( DM6000_IODATA,value);
}*/
#ifndef DM6000_IN_CHAR
#define DM6000_IN_CHAR(addr,data)\
    { \
    sysOutByte( (DM6000_IOADDR),(addr));\
    data = sysInByte(DM6000_IODATA);\
    }
#endif

#ifndef DM6000_IN_ADDR
#define DM6000_IN_ADDR( addr ) \
    addr = sysInByte( (DM6000_IOADDR));
#endif

#ifndef DM6000_OUT_ADDR
#define DM6000_OUT_ADDR( addr ) \
    sysOutByte(DM6000_IOADDR,addr);
#endif

#ifndef DM6000_IN_BYTE
#define DM6000_IN_BYTE( data ) \
    data=sysInByte( (DM6000_IODATA));
#endif

#ifndef DM6000_OUT_BYTE
#define DM6000_OUT_BYTE( data ) \
    sysOutByte( (DM6000_IODATA),(data));
#endif

#ifndef DM6000_IN_WORD
#define DM6000_IN_WORD( data ) \
        data = sysInWord( DM6000_IODATA);
#endif
    
#ifndef DM6000_OUT_WORD
#define DM6000_OUT_WORD( data ) \
        sysOutWord( (DM6000_IODATA),data);
#endif

/* A shortcut for getting the hardware address from the MIB II stuff. */

#define END_HADDR(pEnd) \
        ((pEnd)->mib2Tbl.ifPhysAddress.phyAddress)

#define END_HADDR_LEN(pEnd) \
        ((pEnd)->mib2Tbl.ifPhysAddress.addrLength)

/* typedefs */

typedef struct
{
    int len;
    char * pData;
} PKT;  /* A dummy DMA data packet */

#define DM6000_PKT_LEN_GET(pPkt) (((PKT *)pPkt)->len)
#define DM6000_PKT_DATA_GET(pPkt) (((PKT *)pPkt)->pData)

typedef struct rfd
{
    PKT *  pPkt;
    struct rfd * next;
} RFD;  /* dummy rx frame descriptor */

/* The definition of the driver control structure */

typedef struct end_device
{
    END_OBJ             end;            /* The class we inherit from. */
    END_ERR             err;
    int                 unit;           /* unit number */
    int                 ivec;           /* interrupt vector */
    int                 ilevel;         /* interrupt level */
    long                flags;          /* Our local flags. */
    UCHAR               enetAddr[6];    /* ethernet address */

    CACHE_FUNCS         cacheFuncs;     /* cache function pointers */
    CL_POOL_ID          pClPoolId;      /* cluster pool */
    BOOL                rxHandling;     /* rcv task is scheduled */

    UCHAR               io_mode;        /* 0:word, 2:byte */
    char                tx_pkt_cnt;
    char                device_wait_reset;
    UWORD               queue_pkt_len;
    UCHAR               reg0;           /* registers saved */
    UCHAR               nic_type;       /* NIC type */
    UCHAR               op_mode;        /* PHY operation mode */

    UCHAR               mcastFilter[8]; /* multicast filter */
    int                 txBuf[ETHERMTU + EH_SIZE + 6 + 64];
} END_DEVICE;

/*
 * This will only work if there is only a single unit, for multiple
 * unit device drivers these should be integrated into the END_DEVICE
 * structure.
 */

M_CL_CONFIG dm6000MclBlkConfig =    /* network mbuf configuration table */
{
    /*
    no. mBlks       no. clBlks  memArea     memSize
    -----------     ----------  -------     -------
    */
    0,          0,      NULL,       0
};

CL_DESC dm6000ClDescTbl [] =    /* network cluster pool configuration table */
{
    /*
    clusterSize         num memArea     memSize
    -----------         ----    -------     -------
    */
    {END_BUFSIZ,    0,  NULL,       0}
};

int dm6000ClDescTblNumEnt = (NELEMENTS(dm6000ClDescTbl));

NET_POOL dm6000CmpNetPool;

/* Definitions for the flags field */

#define DM6000_PROMISCUOUS  0x1
#define DM6000_POLLING      0x2

/* Status register bits, returned by dm6000StatusRead() */

#define DM6000_RINT         0x1     /* Rx interrupt pending */
#define DM6000_TINT         0x2     /* Tx interrupt pending */
#define DM6000_VALID_INT    0x3     /* Any valid interrupt pending */
#define DM6000_RXON         0x4     /* Rx on (enabled) */
#define DM6000_TFULL        0x8     /* tx full */
#define DM6000_RXRDY        0x10    /* data rdy */

#define DM6000_MIN_FBUF     (1536)  /* min first buffer size */

/* DEBUG MACROS */

#ifdef DEBUG
#endif /* ENDDEBUG */

#undef DRV_DEBUG
#define DRV_DEBUG 
#define  INT_LOCK()	

#define  INT_UNLOCK(x)	


 int    g_RecvNumError=0;
int	g_RecvNum=0;
int     g_IntrNum=0;
#ifdef  DRV_DEBUG
#define DRV_DEBUG_OFF           0x0000
#define DRV_DEBUG_NO            0x0000
#define DRV_DEBUG_RX            0x0001
#define DRV_DEBUG_TX            0x0002
#define DRV_DEBUG_INT           0x0004
#define DRV_DEBUG_POLL          0x0008
#define DRV_DEBUG_POLL_RX       0x0010
#define DRV_DEBUG_POLL_TX       0x0020
#define DRV_DEBUG_LOAD          0x0040
#define DRV_DEBUG_IOCTL         0x0080
#define DRV_DEBUG_IO            0x0100
#define DRV_DEBUG_STATUS        0x0200
#define DRV_DEBUG_POLL_REDIR    0x0400
#define DRV_DEBUG_LOG_NVRAM     0x0800
#define DRV_PK                  0x1000

int     dm6000Debug = 1;
int     dm6000TxInts = 0;
static  char dbg_array[]={0x0d,0x0a,'\0'};
extern void whz_puts( char * );
extern void whz_puthex( unsigned long int );
#define DRV_LOG(FLG, X0, X1, X2, X3, X4, X5, X6)			\
    {									\
    if (dm6000Debug & FLG)						\
	if (_func_logMsg != NULL)					\
	    _func_logMsg (X0, X1, X2, X3, X4, X5, X6);			\
}

#define DRV_SP( FLG, X0 )\
    {\
    if( dm6000Debug & FLG )\
    {\
        printf(X0);\
    }\
    }

#else /*DRV_DEBUG*/
#define DRV_LOG(DBG_SW, X0, X1, X2, X3, X4, X5, X6)
#define DRV_SP( FLG, X0 )
#endif /*DRV_DEBUG*/

/* LOCALS */
static UCHAR  nfloor = 0;
unsigned long CrcTable[256] = {
   0x00000000L, 0x77073096L, 0xEE0E612CL, 0x990951BAL,
   0x076DC419L, 0x706AF48FL, 0xE963A535L, 0x9E6495A3L,
   0x0EDB8832L, 0x79DCB8A4L, 0xE0D5E91EL, 0x97D2D988L,
   0x09B64C2BL, 0x7EB17CBDL, 0xE7B82D07L, 0x90BF1D91L,
   0x1DB71064L, 0x6AB020F2L, 0xF3B97148L, 0x84BE41DEL,
   0x1ADAD47DL, 0x6DDDE4EBL, 0xF4D4B551L, 0x83D385C7L,
   0x136C9856L, 0x646BA8C0L, 0xFD62F97AL, 0x8A65C9ECL,
   0x14015C4FL, 0x63066CD9L, 0xFA0F3D63L, 0x8D080DF5L,
   0x3B6E20C8L, 0x4C69105EL, 0xD56041E4L, 0xA2677172L,
   0x3C03E4D1L, 0x4B04D447L, 0xD20D85FDL, 0xA50AB56BL,
   0x35B5A8FAL, 0x42B2986CL, 0xDBBBC9D6L, 0xACBCF940L,
   0x32D86CE3L, 0x45DF5C75L, 0xDCD60DCFL, 0xABD13D59L,
   0x26D930ACL, 0x51DE003AL, 0xC8D75180L, 0xBFD06116L,
   0x21B4F4B5L, 0x56B3C423L, 0xCFBA9599L, 0xB8BDA50FL,
   0x2802B89EL, 0x5F058808L, 0xC60CD9B2L, 0xB10BE924L,
   0x2F6F7C87L, 0x58684C11L, 0xC1611DABL, 0xB6662D3DL,
   0x76DC4190L, 0x01DB7106L, 0x98D220BCL, 0xEFD5102AL,
   0x71B18589L, 0x06B6B51FL, 0x9FBFE4A5L, 0xE8B8D433L,
   0x7807C9A2L, 0x0F00F934L, 0x9609A88EL, 0xE10E9818L,
   0x7F6A0DBBL, 0x086D3D2DL, 0x91646C97L, 0xE6635C01L,
   0x6B6B51F4L, 0x1C6C6162L, 0x856530D8L, 0xF262004EL,
   0x6C0695EDL, 0x1B01A57BL, 0x8208F4C1L, 0xF50FC457L,
   0x65B0D9C6L, 0x12B7E950L, 0x8BBEB8EAL, 0xFCB9887CL,
   0x62DD1DDFL, 0x15DA2D49L, 0x8CD37CF3L, 0xFBD44C65L,
   0x4DB26158L, 0x3AB551CEL, 0xA3BC0074L, 0xD4BB30E2L,
   0x4ADFA541L, 0x3DD895D7L, 0xA4D1C46DL, 0xD3D6F4FBL,
   0x4369E96AL, 0x346ED9FCL, 0xAD678846L, 0xDA60B8D0L,
   0x44042D73L, 0x33031DE5L, 0xAA0A4C5FL, 0xDD0D7CC9L,
   0x5005713CL, 0x270241AAL, 0xBE0B1010L, 0xC90C2086L,
   0x5768B525L, 0x206F85B3L, 0xB966D409L, 0xCE61E49FL,
   0x5EDEF90EL, 0x29D9C998L, 0xB0D09822L, 0xC7D7A8B4L,
   0x59B33D17L, 0x2EB40D81L, 0xB7BD5C3BL, 0xC0BA6CADL,
   0xEDB88320L, 0x9ABFB3B6L, 0x03B6E20CL, 0x74B1D29AL,
   0xEAD54739L, 0x9DD277AFL, 0x04DB2615L, 0x73DC1683L,
   0xE3630B12L, 0x94643B84L, 0x0D6D6A3EL, 0x7A6A5AA8L,
   0xE40ECF0BL, 0x9309FF9DL, 0x0A00AE27L, 0x7D079EB1L,
   0xF00F9344L, 0x8708A3D2L, 0x1E01F268L, 0x6906C2FEL,
   0xF762575DL, 0x806567CBL, 0x196C3671L, 0x6E6B06E7L,
   0xFED41B76L, 0x89D32BE0L, 0x10DA7A5AL, 0x67DD4ACCL,
   0xF9B9DF6FL, 0x8EBEEFF9L, 0x17B7BE43L, 0x60B08ED5L,
   0xD6D6A3E8L, 0xA1D1937EL, 0x38D8C2C4L, 0x4FDFF252L,
   0xD1BB67F1L, 0xA6BC5767L, 0x3FB506DDL, 0x48B2364BL,
   0xD80D2BDAL, 0xAF0A1B4CL, 0x36034AF6L, 0x41047A60L,
   0xDF60EFC3L, 0xA867DF55L, 0x316E8EEFL, 0x4669BE79L,
   0xCB61B38CL, 0xBC66831AL, 0x256FD2A0L, 0x5268E236L,
   0xCC0C7795L, 0xBB0B4703L, 0x220216B9L, 0x5505262FL,
   0xC5BA3BBEL, 0xB2BD0B28L, 0x2BB45A92L, 0x5CB36A04L,
   0xC2D7FFA7L, 0xB5D0CF31L, 0x2CD99E8BL, 0x5BDEAE1DL,
   0x9B64C2B0L, 0xEC63F226L, 0x756AA39CL, 0x026D930AL,
   0x9C0906A9L, 0xEB0E363FL, 0x72076785L, 0x05005713L,
   0x95BF4A82L, 0xE2B87A14L, 0x7BB12BAEL, 0x0CB61B38L,
   0x92D28E9BL, 0xE5D5BE0DL, 0x7CDCEFB7L, 0x0BDBDF21L,
   0x86D3D2D4L, 0xF1D4E242L, 0x68DDB3F8L, 0x1FDA836EL,
   0x81BE16CDL, 0xF6B9265BL, 0x6FB077E1L, 0x18B74777L,
   0x88085AE6L, 0xFF0F6A70L, 0x66063BCAL, 0x11010B5CL,
   0x8F659EFFL, 0xF862AE69L, 0x616BFFD3L, 0x166CCF45L,
   0xA00AE278L, 0xD70DD2EEL, 0x4E048354L, 0x3903B3C2L,
   0xA7672661L, 0xD06016F7L, 0x4969474DL, 0x3E6E77DBL,
   0xAED16A4AL, 0xD9D65ADCL, 0x40DF0B66L, 0x37D83BF0L,
   0xA9BCAE53L, 0xDEBB9EC5L, 0x47B2CF7FL, 0x30B5FFE9L,
   0xBDBDF21CL, 0xCABAC28AL, 0x53B39330L, 0x24B4A3A6L,
   0xBAD03605L, 0xCDD70693L, 0x54DE5729L, 0x23D967BFL,
   0xB3667A2EL, 0xC4614AB8L, 0x5D681B02L, 0x2A6F2B94L,
   0xB40BBE37L, 0xC30C8EA1L, 0x5A05DF1BL, 0x2D02EF8DL
};


/* forward static functions */
static void     dmfe_reset_dm6000( END_DEVICE *dev );
static void     dmfe_config_dm6000( END_DEVICE *dev, int oo);
static int      dmfe_start_xmit( PKT *skb, END_DEVICE *dev);
static int      dmfe_packet_receive( PKT *skb, END_DEVICE *dev );
static int      dmfe_stop_dm6000(END_DEVICE *dev);
static void     identify_nic( END_DEVICE *dev );
static void     set_PHY_mode( END_DEVICE *dev );
static void     dm6000_hash_table(END_DEVICE *dev);
static void     program_dm9801( END_DEVICE *dev, UWORD HPNA_rev );
static void     program_dm9802(END_DEVICE *dev);
static UWORD    phy_read( END_DEVICE *dev, int reg );
static void     phy_write( END_DEVICE *dev, int reg, UWORD value);
static UWORD    read_srom_word( END_DEVICE *dev, UCHAR offset);
static void     write_srom_word( END_DEVICE *dev, UCHAR offset, UWORD value );
static unsigned long cal_CRC(unsigned char * Data, unsigned int Len, UCHAR flag);
static void     udelay( int us );
static void     Delay500ns(void);

static void     dm6000Reset(END_DEVICE *pDrvCtrl);
static void     dm6000Config(END_DEVICE *pDrvCtrl);
static void     dm6000Int(END_DEVICE *pDrvCtrl);
static void     dm6000HandleRcvInt(END_DEVICE *pDrvCtrl);
static STATUS   dm6000Recv(END_DEVICE *pDrvCtrl, char* pData);
static UINT     dm6000StatusRead(END_DEVICE *pDrvCtrl);
static void     dm6000needreset( END_DEVICE *pDrvCtrl );

/* END Specific interfaces. */

/* This is the only externally visible interface. */
/* END_OBJ*        dm6000Load (char* initString); */
END_OBJ *   sysEtherEndLoad (char* initString, void *pBSP);

static STATUS   dm6000Start(END_DEVICE* pDrvCtrl);
static STATUS   dm6000Stop(END_DEVICE* pDrvCtrl);
static int      dm6000Ioctl(END_DEVICE* pDrvCtrl, int cmd, caddr_t data);
static STATUS   dm6000Unload(END_DEVICE* pDrvCtrl);
static STATUS   dm6000Send(END_DEVICE* pDrvCtrl, M_BLK_ID pBuf);

static STATUS   dm6000MCastAdd(END_DEVICE* pDrvCtrl, char* pAddress);
static STATUS   dm6000MCastDel(END_DEVICE* pDrvCtrl, char* pAddress);
static STATUS   dm6000MCastGet(END_DEVICE* pDrvCtrl, MULTI_TABLE* pTable);
static STATUS   dm6000PollStart(END_DEVICE* pDrvCtrl);
static STATUS   dm6000PollStop(END_DEVICE* pDrvCtrl);
static STATUS   dm6000PollSend(END_DEVICE* pDrvCtrl, M_BLK_ID pBuf);
static STATUS   dm6000PollRcv(END_DEVICE* pDrvCtrl, M_BLK_ID pBuf);
static void     dm6000AddrFilterSet(END_DEVICE *pDrvCtrl);

static STATUS   dm6000Parse( END_DEVICE * pDrvCtrl, char * initString );
static STATUS   dm6000MemInit( END_DEVICE * pDrvCtrl);

void dm6000Mode( END_DEVICE *pDrvCtrl, int mode, int reset );
/*
 * Declare our function table.  This is static across all driver
 * instances.
 */

static NET_FUNCS dm6000FuncTable =
{
    (FUNCPTR) dm6000Start,      /* Function to start the device. */
    (FUNCPTR) dm6000Stop,       /* Function to stop the device. */
    (FUNCPTR) dm6000Unload,     /* Unloading function for the driver. */
    (FUNCPTR) dm6000Ioctl,      /* Ioctl function for the driver. */
    (FUNCPTR) dm6000Send,       /* Send function for the driver. */
    (FUNCPTR) dm6000MCastAdd,   /* Multicast add function for the */
                                /* driver. */
    (FUNCPTR) dm6000MCastDel,   /* Multicast delete function for */
                                /* the driver. */
    (FUNCPTR) dm6000MCastGet,   /* Multicast retrieve function for */
                                /* the driver. */
    (FUNCPTR) dm6000PollSend,   /* Polling send function */
    (FUNCPTR) dm6000PollRcv,    /* Polling receive function */

    endEtherAddressForm,        /* put address info into a NET_BUFFER */
    endEtherPacketDataGet,      /* get pointer to data in NET_BUFFER */
    endEtherPacketAddrGet       /* Get packet addresses. */
};

/*static isrLink_t sysEndIsrLink =
{
    (void*)dm6000Int,   /* rtn */
    /*0,                  /* arg */
   /* NULL                /* next */
/*};*/

END_DEVICE *DrvCtrl;
/*******************************************************************************
*
* sysEtherEndLoad - initialize the driver and device
*
* This routine initializes the driver and the device to the operational state.
* All of the device specific parameters are passed in the initString.
*
* The string contains the target specific parameters like this:
*
* "register addr:int vector:int level:shmem addr:shmem size:shmem width"
*
* RETURNS: An END object pointer or NULL on error.
*/

END_OBJ* sysEtherEndLoad( char* initString, void *pBSP )    /* String to be parsed by the driver. */
{
    END_DEVICE  *pDrvCtrl;
	char tmp;
    DRV_LOG (DRV_DEBUG_LOAD, "Loading dm6000...", 1, 2, 3, 4, 5, 6);
 /*   printf("loading dm6000......\n");
	DM6000_IN_CHAR(0x28,tmp);
	printf("tmp = %x\n",tmp);*/
    if (initString == NULL)
    {
        DRV_LOG (DRV_DEBUG_LOAD, "initString == NULL", 1, 2, 3, 4, 5, 6);
        return (NULL);
    }

    if (initString[0] == '\0')
    {
        DRV_LOG (DRV_DEBUG_LOAD, "initString[0] == 0", 1, 2, 3, 4, 5, 6);
        bcopy((char *)DM6000_DEV_NAME, initString, DM6000_DEV_NAME_LEN);
        return (NULL);
    }

    /*if (sysMedusaPresent == FALSE)
    {
        DRV_LOG (DRV_DEBUG_LOAD, "sysMedusaPresent == FALSE", 1, 2, 3, 4, 5, 6);
        return NULL;
    }*/

    /* allocate the device structure */

    pDrvCtrl = (END_DEVICE *)calloc(sizeof (END_DEVICE), 1);
    
    DrvCtrl = pDrvCtrl;
    if (pDrvCtrl == NULL)
    {
        DRV_LOG (DRV_DEBUG_LOAD, "calloc() == NULL", 1, 2, 3, 4, 5, 6);
        goto errorExit;
        printf("error exit\n");
    }
    memset( (void*)pDrvCtrl, 0, sizeof( END_DEVICE ) );
    (pDrvCtrl->flags) = 0;
    (pDrvCtrl->op_mode) = DM6000_MEDIA_MODE;

    /* parse the init string, filling in the device structure */

    if (dm6000Parse(pDrvCtrl, initString) == ERROR)
    {
        DRV_LOG (DRV_DEBUG_LOAD, "Parse() == ERROR", 1, 2, 3, 4, 5, 6);
        goto errorExit;
    }

    /* Ask the BSP to provide the ethernet address. */

    dm6000Reset (pDrvCtrl);
    /*printf("reset.....\n");*/
    /* initialize the END and MIB2 parts of the structure */

    /*
     * The M2 element must come from m2Lib.h
     * This dm6000 is set up for a DIX type ethernet device.
     */
    if (END_OBJ_INIT (&pDrvCtrl->end, (DEV_OBJ *)pDrvCtrl, DM6000_DEV_NAME,
                      pDrvCtrl->unit, &dm6000FuncTable,
                      "END Template Driver.") == ERROR
     || END_MIB_INIT (&pDrvCtrl->end, M2_ifType_ethernet_csmacd,
                      &pDrvCtrl->enetAddr[0], 6, END_BUFSIZ,
                      END_SPEED)
            == ERROR)
    {
        DRV_LOG (DRV_DEBUG_LOAD, "END_OBJ_INIT() == END_MIB_INIT()==ERROR", 1, 2, 3, 4, 5, 6);
        printf("obj init error\n");
        goto errorExit;
    }

    /* Perform memory allocation/distribution */

    if (dm6000MemInit (pDrvCtrl) == ERROR)
    {
        DRV_LOG (DRV_DEBUG_LOAD, "MemInit() == ERROR", 1, 2, 3, 4, 5, 6);
        goto errorExit;
    }

    /* reset and reconfigure the device */

    dm6000Reset (pDrvCtrl);
    dm6000Config (pDrvCtrl);

    /* set the flags to indicate readiness */

    END_OBJ_READY (&pDrvCtrl->end,
                 IFF_UP | IFF_RUNNING | IFF_NOTRAILERS | IFF_BROADCAST | IFF_MULTICAST | IFF_SIMPLEX);
		
    DRV_LOG (DRV_DEBUG_LOAD, "Done loading Template...", 1, 2, 3, 4, 5, 6);
    /*printf("Done loading Template...\n");*/
	
    return (&pDrvCtrl->end);

errorExit:
    if (pDrvCtrl != NULL)
    free ((char *)pDrvCtrl);

    return NULL;
}

/*******************************************************************************
*
* dm6000Parse - parse the init string
*
* Parse the input string.  Fill in values in the driver control structure.
*
* The muxLib.o module automatically prepends the unit number to the user's
* initialization string from the BSP (configNet.h).
*
* .IP <unit>
* Device unit number, a small integer.
* .IP <vecNum>
* Interrupt vector number (used with sysIntConnect)
* .IP <intLvl>
* Interrupt level
* .LP
*
* RETURNS: OK or ERROR for invalid arguments.
*/

static STATUS dm6000Parse( END_DEVICE * pDrvCtrl,  /* device pointer */
                           char * initString )     /* information string */
{
    int               tmp1;
    unsigned long int tmp2, tmp3, tmp4;
    int               tmp5;

    /* Parse the initString */

    DRV_LOG (DRV_DEBUG_LOAD, "dm6000Parse()", 1, 2, 3, 4, 5, 6);
    DRV_LOG (DRV_DEBUG_LOAD, initString, 1, 2, 3, 4, 5, 6);
    if (sscanf(initString, "%d:%d:%lx:%lx:%lx:%d",
            &tmp1,
            &(pDrvCtrl->unit),
            &tmp2,
            &tmp3,
            &tmp4,
            &tmp5 ) != 6 /* the number of parameters */ )
        return ERROR;
    pDrvCtrl->ivec =  0x23;
    pDrvCtrl->ilevel = 0x3;
    /*printf("parm ok\n");*/
    return OK;
}

/*******************************************************************************
*
* dm6000MemInit - initialize memory for the chip
*
* This routine is highly specific to the device.
*
* RETURNS: OK or ERROR.
*/

static STATUS dm6000MemInit( END_DEVICE * pDrvCtrl )    /* device to be initialized */
{
     /* This is how we would set up and END netPool using netBufLib(1).
     * This code is pretty generic.
     */

    if ((pDrvCtrl->end.pNetPool = malloc (sizeof(NET_POOL))) == NULL)
        return (ERROR);

    dm6000MclBlkConfig.mBlkNum = 128; /*16;*/
    dm6000ClDescTbl[0].clNum = 128;  /*16;*/
    dm6000MclBlkConfig.clBlkNum = dm6000ClDescTbl[0].clNum;

    /* Calculate the total memory for all the M-Blks and CL-Blks. */

    dm6000MclBlkConfig.memSize = (dm6000MclBlkConfig.mBlkNum *
                                 (MSIZE + sizeof (long))) +
                                 (dm6000MclBlkConfig.clBlkNum *
                                 (CL_BLK_SZ + sizeof(long)));

    if ((dm6000MclBlkConfig.memArea = (char *) memalign (sizeof(long),
                                 dm6000MclBlkConfig.memSize)) == NULL)
        return (ERROR);

    /* Calculate the memory size of all the clusters. */

    dm6000ClDescTbl[0].memSize = (dm6000ClDescTbl[0].clNum *
                                 (END_BUFSIZ + 8)) + sizeof(int);

    /* Allocate the memory for the clusters from cache safe memory. */

    if ((dm6000ClDescTbl[0].memArea = (char *) memalign ( sizeof(long),
                                  dm6000ClDescTbl[0].memSize)) == NULL)
        return (ERROR);

    if ((int)dm6000ClDescTbl[0].memArea == NULL)
    {
        DRV_LOG (DRV_DEBUG_LOAD, "system memory unavailable",
        1, 2, 3, 4, 5, 6);
        return (ERROR);
    }

    /* Initialize the memory pool. */

    if (netPoolInit(pDrvCtrl->end.pNetPool, &dm6000MclBlkConfig,
                    &dm6000ClDescTbl[0], dm6000ClDescTblNumEnt,
            NULL) == ERROR)
        {
        DRV_LOG (DRV_DEBUG_LOAD, "Could not init buffering",
        1, 2, 3, 4, 5, 6);
        return (ERROR);
        }

    /*
     * If you need clusters to store received packets into then get them
     * here ahead of time.
     */

    if ((pDrvCtrl->pClPoolId = netClPoolIdGet (pDrvCtrl->end.pNetPool,
        (END_BUFSIZ), FALSE))
        == NULL)
        return (ERROR);
   DRV_LOG (DRV_DEBUG_LOAD, "Memory setup complete", 1, 2, 3, 4, 5, 6);

    return OK;
}

/*******************************************************************************
*
* dm6000Start - start the device
*
* This function calls BSP functions to connect interrupts and start the
* device running in interrupt mode.
*
* RETURNS: OK or ERROR
*
*/

static STATUS dm6000Start( END_DEVICE * pDrvCtrl )  /* device ID */
{
    STATUS result;

    DRV_LOG (DRV_DEBUG_LOAD, "dm6000Start.", 1, 2, 3, 4, 5, 6);
    /*printf("dm6000 startd\n");*/
   /* sysEndIsrLink.arg = (int)pDrvCtrl;*/
    SYS_INT_CONNECT (pDrvCtrl, dm6000Int, (int)pDrvCtrl, &result);
    /*result = intConnect ((VOIDFUNCPTR *)INUM_TO_IVEC (pDrvCtrl->ivec), \
			     dm6000Int, 0);*/
    if (result == ERROR)
    {
        printf("interrupt connect error\n");
        return ERROR;
    }
    /*printf("Interrupt connected.\n");*/
    DRV_LOG (DRV_DEBUG_LOAD, "Interrupt connected.", 1, 2, 3, 4, 5, 6);

   /* SYS_INT_ENABLE (pDrvCtrl);*/
    sysIntEnablePIC (pDrvCtrl->ilevel);
    DRV_LOG (DRV_DEBUG_LOAD, "interrupt enabled.", 1, 2, 3, 4, 5, 6);

    /* TODO - start the device, enabling interrupts */

    /* Activate DM6000 */
    DM6000_OUT_CHAR( 0x05, DM6000_REG05 | 1 );      /* RX enable */
    DM6000_OUT_CHAR( 0xff, DM6000_REGFF );          /* Enable TX/RX interrupt mask */

    return (OK);
}

/*******************************************************************************
*
* dm6000Int - handle controller interrupt
*
* This routine is called at interrupt level in response to an interrupt from
* the controller.
*
* RETURNS: N/A.
*/

static void dm6000Int( END_DEVICE  *pDrvCtrl  )  /* interrupting device */
{
    UCHAR stat, reg_save, isr_status, nsr_status; /* tx_status, */

    /*if( !PIC_CHECK_EXT1() )
        return;
    PIC_CLEAR_EXT1();*/
	
    /* TODO */

    /* Save previous register address */
    /*printf("in Interrupt\n");*/
    sysIntDisablePIC (pDrvCtrl->ilevel);
    DM6000_IN_ADDR( reg_save );
    /* Disable all interrupt */
    /*DM6000_OUT_CHAR( 0x05, 0x00 );*/
    DM6000_OUT_CHAR( 0xff, 0x80 );

    /* Read the device status register */

    stat = dm6000StatusRead (pDrvCtrl);
    /* Clear NSR status */
    DM6000_IN_CHAR( 0x01, nsr_status );
    /* Clear ISR status */
    DM6000_IN_CHAR( 0xfe, isr_status );
    DM6000_OUT_CHAR( 0xfe, isr_status );

    DRV_LOG (DRV_DEBUG_INT, "Got an interrupt!", 1, 2, 3, 4, 5, 6);
    if( (!(nsr_status & 0x40)) || (pDrvCtrl->device_wait_reset == 1) )
    {
        DRV_LOG (DRV_DEBUG_STATUS, "Got an link failed interrupt!", 1, 2, 3, 4, 5, 6);

        netJobAdd ((FUNCPTR) muxError, (int) &(pDrvCtrl->end),
               (int) &(pDrvCtrl->err), 0, 0, 0);

        netJobAdd ((FUNCPTR)dm6000needreset, (int)(pDrvCtrl),
                   0, 0, 0, 0);

        logMsg("reset 6000\n",0,0,0,0,0,0);  
        goto intRet;
    }

    /*
     * enable interrupts, clear receive and/or transmit interrupts, and clear
     * any errors that may be set.
     */

    /* TODO - Check for errors */

    /* Have netTask handle any input packets */
    if( (isr_status & 1 )&&(stat & DM6000_RXON) )
    {
        DRV_LOG (DRV_DEBUG_INT, "Handle an RX interrupt!", 1, 2, 3, 4, 5, 6);
        if ( pDrvCtrl->rxHandling != TRUE )
        {
            pDrvCtrl->rxHandling = TRUE;
            /*dm6000HandleRcvInt(pDrvCtrl);*/
#ifdef DRV_DEBUG
g_IntrNum++;
#endif
            netJobAdd ((FUNCPTR)dm6000HandleRcvInt, (int)pDrvCtrl,
                       0,0,0,0);
            DRV_SP( DRV_PK,"^" );
        }
    }

    /* TODO - handle transmit interrupts */

    if( isr_status & 2 )
    {
         DRV_LOG (DRV_DEBUG_INT, "Got an TX interrupt!", pDrvCtrl->tx_pkt_cnt, 2, 3, 4, 5, 6);
        /* Trnasmit Interrupt check */
        /*DM6000_IN_CHAR( 0x01, tx_status );   Got TX status */
        /*if( tx_status & 0xc) */
        if( pDrvCtrl->tx_pkt_cnt > 0 )
        {
            DRV_SP( DRV_PK,"x" );
            /* One packet sent complete */
            pDrvCtrl->tx_pkt_cnt--;
            /* Queue packet check & send */
            if( pDrvCtrl->tx_pkt_cnt > 0)
            {
                DM6000_OUT_CHAR( 0xfc,  pDrvCtrl->queue_pkt_len & 0xff );
                DM6000_OUT_CHAR( 0xfd, (pDrvCtrl->queue_pkt_len >> 8) & 0xff );
                DM6000_OUT_CHAR( 0x2, 0x1 );
            }
        }
    }

intRet:
    /* Re-enable interrupt mask */
    DM6000_OUT_CHAR( 0xff, 0x83 );
    /*DM6000_OUT_CHAR( 0x05, 0x11 );*/
    /* Restore previous register address */
    DM6000_OUT_ADDR( reg_save );
    sysIntEnablePIC (pDrvCtrl->ilevel);
}


/*******************************************************************************
*
* dm6000PacketGet - get next received message
*
* Get next received message.  Returns NULL if none are
* ready.
*
* RETURNS: ptr to next packet, or NULL if none ready.
*/

STATUS dm6000PacketGet( END_DEVICE  *pDrvCtrl  )
{
    UCHAR rxbyte;

    /* TODO - get next received packet */

    /* Check packet ready or not */
    DM6000_IN_CHAR( 0xf0, rxbyte ); /* Dummy read */
    DM6000_IN_CHAR( 0xf0, rxbyte ); /* Got most updated data */

    /* packet ready to receive check */
    if( rxbyte == DM6000_PKT_RDY )
    {
        DRV_LOG (DRV_DEBUG_LOAD, "dm6000PacketGet() != NULL", 1, 2, 3, 4, 5, 6);
        return OK;
    }

    DRV_LOG (DRV_DEBUG_LOAD, "dm6000PacketGet() == NULL", 1, 2, 3, 4, 5, 6);
    return ERROR;
}


/*******************************************************************************
*
* dm6000Recv - process the next incoming packet
*
* Handle one incoming packet.  The packet is checked for errors.
*
* RETURNS: N/A.
*/

static STATUS dm6000Recv( END_DEVICE *pDrvCtrl,   /* device structure */
                         char* pData )           /* packet to process */
{
    char*       pClusterData;
    M_BLK_ID    pMblk;
    char*       pNewCluster;
    CL_BLK_ID   pClBlk;
    PKT         skb;

    DRV_LOG (DRV_DEBUG_LOAD, "dm6000Recv()", 1, 2, 3, 4, 5, 6);

    /* TODO - Packet must be checked for errors. */

    /* Add one to our unicast data.

    END_ERR_ADD (&pDrvCtrl->end, MIB2_IN_UCAST, +1); */

    /*
     * We implicitly are loaning here, if copying is necessary this
     * step may be skipped, but the data must be copied before being
     * passed up to the protocols.
     */
#ifdef     DRV_DEBUG
    g_RecvNumError++;  
#endif    


    pNewCluster = netClusterGet (pDrvCtrl->end.pNetPool, pDrvCtrl->pClPoolId);

    if (pNewCluster == NULL)
    {
        DRV_LOG (DRV_DEBUG_RX, "Cannot loan!", 1, 2, 3, 4, 5, 6);
        END_ERR_ADD (&pDrvCtrl->end, MIB2_IN_ERRS, +1);
        goto cleanRXD;
    }

    /* Grab a cluster block to marry to the cluster we received. */

    if ((pClBlk = netClBlkGet (pDrvCtrl->end.pNetPool, M_DONTWAIT)) == NULL)
    {
        netClFree (pDrvCtrl->end.pNetPool, pNewCluster);
        DRV_LOG (DRV_DEBUG_RX, "Out of Cluster Blocks!", 1, 2, 3, 4, 5, 6);
        END_ERR_ADD (&pDrvCtrl->end, MIB2_IN_ERRS, +1);
        goto cleanRXD;
    }

    /*
     * OK we've got a spare, let's get an M_BLK_ID and marry it to the
     * one in the ring.
     */

    if ((pMblk = mBlkGet (pDrvCtrl->end.pNetPool, M_DONTWAIT, MT_DATA)) == NULL)
    {
        netClBlkFree (pDrvCtrl->end.pNetPool, pClBlk);
        netClFree (pDrvCtrl->end.pNetPool, pNewCluster);
        DRV_LOG (DRV_DEBUG_RX, "Out of M Blocks!", 1, 2, 3, 4, 5, 6);
        END_ERR_ADD (&pDrvCtrl->end, MIB2_IN_ERRS, +1);
        goto cleanRXD;
    }

    END_ERR_ADD (&pDrvCtrl->end, MIB2_IN_UCAST, +1);

    /* align IP header at 32-bit boundary, this is reqired by VxWorks
    ** TCP/IP stack
    */
    pClusterData = (char*)((((unsigned long)pNewCluster + 1) & (~1)) | 2 );

    /* move packet from Ethernet on-board SRAM to the mbuf pre-allocated
    ** in system memory
    */
    skb.pData = pClusterData;
    skb.len = 0;
    if( dmfe_packet_receive( (PKT*)(&skb), pDrvCtrl ) )
    {
        mBlkFree (pDrvCtrl->end.pNetPool, pMblk);
        netClBlkFree (pDrvCtrl->end.pNetPool, pClBlk);
        netClFree (pDrvCtrl->end.pNetPool, pNewCluster);
        DRV_LOG (DRV_DEBUG_RX, "no data!", 1, 2, 3, 4, 5, 6);
        END_ERR_ADD (&pDrvCtrl->end, MIB2_IN_ERRS, +1);
        goto cleanRXD;
    }

    /*pCluster = END_CACHE_PHYS_TO_VIRT (pData); */

    /* Join the cluster to the MBlock */

    /*netClBlkJoin (pClBlk, pCluster, len, NULL, 0, 0, 0);*/
    netClBlkJoin (pClBlk, pNewCluster, skb.len, NULL, 0, 0, 0);
    netMblkClJoin (pMblk, pClBlk);

    pMblk->mBlkHdr.mData = pClusterData;
    pMblk->mBlkHdr.mLen = skb.len;
    pMblk->mBlkHdr.mFlags |= M_PKTHDR;
    pMblk->mBlkPktHdr.len = skb.len;

    /* make the packet data coherent */

    END_CACHE_INVALIDATE (pMblk->mBlkHdr.mData, skb.len);

    DRV_LOG (DRV_DEBUG_NO, "Calling upper layer!", 1, 2, 3, 4, 5, 6);

    /* TODO - Done with processing, clean up and pass it up. */

    /* Call the upper layer's receive routine. */
    END_ERR_ADD (&pDrvCtrl->end, MIB2_IN_UCAST, +1);

   /* DM6000_OUT_CHAR( 0x05, DM6000_REG05 );   */   /* RX disable */
    /*DM6000_OUT_CHAR( 0xff, 80 );               */ /* disable TX/RX interrupt mask */
    END_RCV_RTN_CALL(&pDrvCtrl->end, pMblk);
    /*DM6000_OUT_CHAR( 0x05, DM6000_REG05 | 1 );    */  /* RX enable */
    /*DM6000_OUT_CHAR( 0xff, DM6000_REGFF );    */      /* Enable TX/RX interrupt mask */
#ifdef     DRV_DEBUG
    g_RecvNum++;  
    g_RecvNumError--;  
#endif
    return (OK);    
cleanRXD:

    return (ERROR);
}

/*******************************************************************************
*
* dm6000HandleRcvInt - task level interrupt service for input packets
*
* This routine is called at task level indirectly by the interrupt
* service routine to do any message received processing.
*
* The double loop is to protect against a race condition where the interrupt
* code see rxHandling as TRUE, but it is then turned off by task code.
* This race is not fatal, but does cause occassional delays until a second
* packet is received and then triggers the netTask to call this routine again.
*
* RETURNS: N/A.
*/

static void dm6000HandleRcvInt( END_DEVICE *pDrvCtrl )   /* interrupting device */
{
    char* pData;
    int i; 
    unsigned short tmp3;
/*    DRV_LOG (0xFFFF, "dm6000HandleRcvInt()_IN", 1, 2, 3, 4, 5, 6);*/
/*    do*/
/*    {*/
        pDrvCtrl->rxHandling = TRUE;

        while (OK==dm6000PacketGet (pDrvCtrl)) 
          {
            if(dm6000Recv (pDrvCtrl, (char*)NULL ) == ERROR)
            	{
            	
            	break;
            	}	
        }

        pDrvCtrl->rxHandling = FALSE;

/*    }while (dm6000PacketGet (pDrvCtrl) != NULL); */
/*    DRV_LOG (0xFFFF, "dm6000HandleRcvInt()_OUT", 1, 2, 3, 4, 5, 6);*/
}

/*******************************************************************************
*
* dm6000Send - the driver send routine
*
* This routine takes a M_BLK_ID sends off the data in the M_BLK_ID.
* The buffer must already have the addressing information properly installed
* in it.  This is done by a higher layer.  The last arguments are a free
* routine to be called when the device is done with the buffer and a pointer
* to the argument to pass to the free routine.
*
* RETURNS: OK, ERROR, or END_ERR_BLOCK.
*/

static STATUS dm6000Send( END_DEVICE * pDrvCtrl,  /* device ptr */
                         M_BLK_ID     pMblk )    /* data to send */
{
    int         oldLevel = 0;
    BOOL        freeNow = TRUE;
    PKT         skb;

    int         len;

    DRV_LOG (DRV_DEBUG_LOAD, "dm6000Send()", (pDrvCtrl->flags), 2, 3, 4, 5, 6);
    /*
     * Obtain exclusive access to transmitter.  This is necessary because
     * we might have more than one stack transmitting at once.
     */

    if (!((pDrvCtrl->flags) & DM6000_POLLING))
        END_TX_SEM_TAKE (&pDrvCtrl->end, WAIT_FOREVER);

    /* This is the normal case where all the data is in one M_BLK_ID */

    /* Set pointers in local structures to point to data. */

    /*
     * If no buffers are available,
     * release the semaphore and return END_ERR_BLOCK.
     * Do not free packet
     */

    /* place a transmit request */

    /*if (!((pDrvCtrl->flags) & DM6000_POLLING))*/
        oldLevel = intLock ();  /* protect dm6000Int */

    /* TODO - initiate device transmit */
    len = netMblkToBufCopy (pMblk, (char*)(pDrvCtrl->txBuf), NULL);
    len = max (len, ETHERSMALL);

    skb.len = len;
    skb.pData = (char*)pDrvCtrl->txBuf;


    if( dmfe_start_xmit( &skb, pDrvCtrl ) )          
    {
        DRV_LOG (DRV_DEBUG_STATUS, "dm6000Send() fail", 1, 2, 3, 4, 5, 6);
        freeNow = FALSE;

        /* Advance our management index(es) */
        /*if (!((pDrvCtrl->flags) & DM6000_POLLING))*/
            intUnlock (oldLevel);

        if (!((pDrvCtrl->flags) & DM6000_POLLING))
            END_TX_SEM_GIVE (&pDrvCtrl->end);

        return(END_ERR_BLOCK);
    }

    /* Advance our management index(es) */

    /*if (!((pDrvCtrl->flags) & DM6000_POLLING))*/
        intUnlock (oldLevel);

    if (!((pDrvCtrl->flags) & DM6000_POLLING))
        END_TX_SEM_GIVE (&pDrvCtrl->end);


    /* Bump the statistics counters. */

    END_ERR_ADD (&pDrvCtrl->end, MIB2_OUT_UCAST, +1);

    /*
     * Cleanup.  The driver must either free the packet now or
     * set up a structure so it can be freed later after a transmit
     * interrupt occurs.
     */

    if (freeNow)
        netMblkClChainFree (pMblk);

    return (OK);
}

/*******************************************************************************
*
* dm6000Ioctl - the driver I/O control routine
*
* Process an ioctl request.
*
* RETURNS: A command specific response, usually OK or ERROR.
*/

static int dm6000Ioctl( END_DEVICE * pDrvCtrl,   /* device receiving command */
                       int cmd,                 /* ioctl command code */
                       caddr_t data )           /* command argument */
{
    int error = 0;
    long value;

    DRV_LOG (DRV_DEBUG_LOAD, "dm6000Ioctl()", 1, 2, 3, 4, 5, 6);

    switch (cmd)
    {
        case EIOCSADDR:
        DRV_LOG (DRV_DEBUG_LOAD, "EIOICSADDR", 1, 2, 3, 4, 5, 6);
            if (data == NULL)
                return (EINVAL);
            bcopy ((char *)data, (char *)END_HADDR(&pDrvCtrl->end),
            END_HADDR_LEN(&pDrvCtrl->end));
            break;
        case EIOCGADDR:
        DRV_LOG (DRV_DEBUG_LOAD, "EIOCGADDR", 1, 2, 3, 4, 5, 6);
            if (data == NULL)
                return (EINVAL);
            bcopy ((char *)END_HADDR(&pDrvCtrl->end), (char *)data,
            END_HADDR_LEN(&pDrvCtrl->end));
            break;
        case EIOCSFLAGS:
        DRV_LOG (DRV_DEBUG_LOAD, "EIOCSFLAGS", 1, 2, 3, 4, 5, 6);
            value = (long)data;
            if (value < 0)
            {
                value = -(--value);
                END_FLAGS_CLR (&pDrvCtrl->end, value);
            }
            else
            {
                END_FLAGS_SET (&pDrvCtrl->end, value);
            }
            dm6000Config (pDrvCtrl);
            break;
        case EIOCGFLAGS:
        DRV_LOG (DRV_DEBUG_LOAD, "EIOCGFLAGS", 1, 2, 3, 4, 5, 6);
            *(int *)data = END_FLAGS_GET(&pDrvCtrl->end);
            break;

        case EIOCPOLLSTART: /* Begin polled operation */
        DRV_LOG (DRV_DEBUG_LOAD, "begin polled operation", 1, 2, 3, 4, 5, 6);
            dm6000PollStart (pDrvCtrl);
            break;

        case EIOCPOLLSTOP:  /* End polled operation */
        DRV_LOG (DRV_DEBUG_LOAD, "end polled operation", 1, 2, 3, 4, 5, 6);
            dm6000PollStop (pDrvCtrl);
            break;

        case EIOCGMIB2:     /* return MIB information */
        DRV_LOG (DRV_DEBUG_LOAD, "return MIB information", 1, 2, 3, 4, 5, 6);
            if (data == NULL)
                return (EINVAL);
            bcopy((char *)&pDrvCtrl->end.mib2Tbl,
                  (char *)data,
                  sizeof(pDrvCtrl->end.mib2Tbl));
            break;
        case EIOCGFBUF:     /* return minimum First Buffer for chaining */
        DRV_LOG (DRV_DEBUG_LOAD, "return minimun first buffer for chaining", 1, 2, 3, 4, 5, 6);
            if (data == NULL)
                return (EINVAL);
            *(int *)data = DM6000_MIN_FBUF;
            break;
        default:
        DRV_LOG (DRV_DEBUG_LOAD, "error", 1, 2, 3, 4, 5, 6);
            error = EINVAL;
    }
    return (error);
}

/******************************************************************************
*
* dm6000Mode - configure the interface mode
*
* mode:
* #define DM6000_10MHD        0
* #define DM6000_100MHD       1
* #define DM6000_10MFD        4
* #define DM6000_100MFD       5
* #define DM6000_AUTO         8
* RETURNS: N/A.
*/
void     dm6000Mode( END_DEVICE *pDrvCtrl, int mode, int reset )
{
    if( pDrvCtrl != 0 )
    {
        printf("pDrvCtrl->op_mode = %d\n",(int)(pDrvCtrl->op_mode) );
        pDrvCtrl->op_mode = (UCHAR)mode;
        printf("pDrvCtrl->op_mode = %d\n",(int)(pDrvCtrl->op_mode) );
        if( reset != 0 )
        {
            dm6000Reset( pDrvCtrl );
            dm6000Config( pDrvCtrl );
        }
    }
    else
    {
        printf("DrvCtrl->op_mode = %d\n",(int)(DrvCtrl->op_mode) );
        DrvCtrl->op_mode = (UCHAR)mode;
        printf("DrvCtrl->op_mode = %d\n",(int)(DrvCtrl->op_mode) );
        if( reset != 0 )
        {
            dm6000Reset( DrvCtrl );
            dm6000Config( DrvCtrl );
        }
    }
}

/******************************************************************************
*
* dm6000Config - reconfigure the interface under us.
*
* Reconfigure the interface setting promiscuous mode, and changing the
* multicast interface list.
*
* RETURNS: N/A.
*/

static void dm6000Config( END_DEVICE *pDrvCtrl ) /* device to be re-configured */
{
    /* Set promiscuous mode if it's asked for. */
    DRV_LOG (DRV_DEBUG_LOAD, "dm6000Config()", 1, 2, 3, 4, 5, 6);

    if (END_FLAGS_GET(&pDrvCtrl->end) & IFF_PROMISC)
    {
        DRV_LOG (DRV_DEBUG_IOCTL, "Setting promiscuous mode on!",
                 1, 2, 3, 4, 5, 6);
    }
    else
    {
        DRV_LOG (DRV_DEBUG_IOCTL, "Setting promiscuous mode off!",
                 1, 2, 3, 4, 5, 6);
    }

    /* Set up address filter for multicasting. */

    if (END_MULTI_LST_CNT(&pDrvCtrl->end) > 0)
    {
        dm6000AddrFilterSet (pDrvCtrl);
        dm6000_hash_table( pDrvCtrl ); 
    }

    /* TODO - shutdown device completely */

    /* TODO - reset all device counters/pointers, etc. */

    /* TODO - initialise the hardware according to flags */
    dmfe_config_dm6000( pDrvCtrl, 2 );

    DRV_LOG (DRV_DEBUG_LOAD, "dm6000Config() done", 1, 2, 3, 4, 5, 6);
    return;
}


static void dm6000needreset( END_DEVICE *pDrvCtrl )
{
    int oldv;

    DRV_LOG (DRV_DEBUG_STATUS, "dm6000needreset()", 1, 2, 3, 4, 5, 6);

    oldv = intLock();
    pDrvCtrl->device_wait_reset = 0;

    dm6000Reset( pDrvCtrl );
    dm6000Config( pDrvCtrl );
    intUnlock( oldv );
}
/******************************************************************************
*
* dm6000AddrFilterSet - set the address filter for multicast addresses
*
* This routine goes through all of the multicast addresses on the list
* of addresses (added with the endAddrAdd() routine) and sets the
* device's filter correctly.
*
* RETURNS: N/A.
*/

void dm6000AddrFilterSet( END_DEVICE *pDrvCtrl )
{
    int i;
    unsigned long crc; 
    unsigned long hash_table[4];
    ETHER_MULTI* pCurr;
    
    pDrvCtrl->mcastFilter[0] = 0;
    pDrvCtrl->mcastFilter[1] = 0;
    pDrvCtrl->mcastFilter[2] = 0;
    pDrvCtrl->mcastFilter[3] = 0;
    pDrvCtrl->mcastFilter[4] = 0;
    pDrvCtrl->mcastFilter[5] = 0;
    pDrvCtrl->mcastFilter[6] = 0;
    pDrvCtrl->mcastFilter[7] = 0;
    
    for(i=0;i<4;i++)hash_table[i]=0;
    hash_table[3]=0x8000;
    
    /* broadcast address */
    /*pDrvCtrl->mcastFilter[7] = 0x80; */      /*mabe  [6] */

    /* the multicast address in Hash Table : 64 bits */

    pCurr = END_MULTI_LST_FIRST (&pDrvCtrl->end);

    while (pCurr != NULL)
    {
        /* TODO - set up the multicast list */
        crc = cal_CRC(((unsigned char *)&pCurr->addr), 6, 0 )&0x3f;
        hash_table[crc/16] |= (unsigned short) 1 << (crc % 16);
        
    pCurr = END_MULTI_LST_NEXT(pCurr);     
    }
 
       pDrvCtrl->mcastFilter[0] |= hash_table[0]&0xff;
       pDrvCtrl->mcastFilter[1] |= (hash_table[0]>>8)&0xff;
       pDrvCtrl->mcastFilter[2] |= hash_table[1]&0xff;
       pDrvCtrl->mcastFilter[3] |= (hash_table[1]>>8)&0xff;
       pDrvCtrl->mcastFilter[4] |= hash_table[2]&0xff;
       pDrvCtrl->mcastFilter[5] |= (hash_table[2]>>8)&0xff;
       pDrvCtrl->mcastFilter[6] |= hash_table[3]&0xff;
       pDrvCtrl->mcastFilter[7] |= (hash_table[3]>>8)&0xff;
}

#if 0
void dm6000AddrFilterSet( END_DEVICE *pDrvCtrl )    /* device to be updated */
{
    ETHER_MULTI* pCurr;
    u_long crc;

    DRV_LOG (DRV_DEBUG_LOAD, "dm6000AddrFilterSet()", 1, 2, 3, 4, 5, 6);

    /* TODO - clean the device filter list */
    pDrvCtrl->mcastFilter[0] = 0;
    pDrvCtrl->mcastFilter[1] = 0;
    pDrvCtrl->mcastFilter[2] = 0;
    pDrvCtrl->mcastFilter[3] = 0;
    pDrvCtrl->mcastFilter[4] = 0;
    pDrvCtrl->mcastFilter[5] = 0;
    pDrvCtrl->mcastFilter[6] = 0;
    pDrvCtrl->mcastFilter[7] = 0;

    pCurr = END_MULTI_LST_FIRST (&pDrvCtrl->end);

    while (pCurr != NULL)
    {
        /* TODO - set up the multicast list */

        /* build the CRC for the 6 byte adrs */
        crc = cal_CRC( ((unsigned char *)&pCurr->addr), 6, 0 );

        
        /* get six msb */
        crc >>= 26;
        crc &= 0x3f;

        /* high 3 bit index MAR reg, low three bits index reg bit */
        pDrvCtrl->mcastFilter[crc >> 3] |= (1 << (crc & 7));

        
        pCurr = END_MULTI_LST_NEXT(pCurr);
    }

    /* TODO - update the device filter list */

    
}
#endif
/*******************************************************************************
*
* dm6000PollRcv - routine to receive a packet in polled mode.
*
* This routine is called by a user to try and get a packet from the
* device.
*
* RETURNS: OK upon success.  EAGAIN is returned when no packet is available.
*/

static STATUS dm6000PollRcv( END_DEVICE *pDrvCtrl,  /* device to be polled */
                            M_BLK_ID   pMblk )     /* ptr to buffer */
{
    u_short stat;
    char* pPacket;
    int len;
    PKT         skb;

    DRV_LOG (DRV_DEBUG_POLL_RX, "dm6000PollRcv", 1, 2, 3, 4, 5, 6);

    stat = dm6000StatusRead (pDrvCtrl);
    /* TODO - If no packet is available return immediately */

    if( !(stat&DM6000_RXRDY) )
    {
        DRV_LOG (DRV_DEBUG_POLL_RX, "dm6000PollRcv no data", 1,
                 2, 3, 4, 5, 6);
        return (EAGAIN);
    }

    
    pPacket = NULL; /* DUMMY CODE */
    len = 64;       /* DUMMY CODE */

    /* Upper layer must provide a valid buffer. */

    if ((pMblk->mBlkHdr.mLen < len) || (!(pMblk->mBlkHdr.mFlags & M_EXT)))
    {
        DRV_LOG (DRV_DEBUG_POLL_RX, "PRX bad mblk", 1, 2, 3, 4, 5, 6);
        return (EAGAIN);
    }

    /* TODO - clear any status bits that may be set. */

    /* TODO - Check packet and device for errors */

    END_ERR_ADD (&pDrvCtrl->end, MIB2_IN_UCAST, +1);

    /* TODO - Process device packet into net buffer */
    skb.len = 0;
    skb.pData = pMblk->m_data;
    if( dmfe_packet_receive( &skb, pDrvCtrl ) )
    {
        DRV_LOG (DRV_DEBUG_POLL_RX, "packet receive FAIL", 1, 2, 3, 4, 5, 6);
        return (EAGAIN);
    }

/*    bcopy (pPacket, pMblk->m_data, len);   */
    pMblk->mBlkHdr.mFlags |= M_PKTHDR;  /* set the packet header */
    pMblk->mBlkHdr.mLen = len;          /* set the data len */
    pMblk->mBlkPktHdr.len = len;        /* set the total len */

    /* TODO - Done with packet, clean up and give it to the device. */

    DRV_LOG (DRV_DEBUG_POLL_RX, "dm6000PollRcv OK", 1, 2, 3, 4, 5, 6);
    DRV_LOG (DRV_DEBUG_POLL_RX, "dm6000PollRcv OK", 1, 2, 3, 4, 5, 6);

    return (OK);
}

/*******************************************************************************
*
* dm6000PollSend - routine to send a packet in polled mode.
*
* This routine is called by a user to try and send a packet on the
* device.
*
* RETURNS: OK upon success.  EAGAIN if device is busy.
*/

static STATUS dm6000PollSend( END_DEVICE *pDrvCtrl,   /* device to be polled */
                             M_BLK_ID   pMblk )      /* packet to send */
{
    int         len;
    u_short     stat;
    PKT         skb;
    int         oldv;

    DRV_LOG (DRV_DEBUG_POLL_TX, "dm6000PollSend", 1, 2, 3, 4, 5, 6);

    /* TODO - test to see if tx is busy */
    stat = dm6000StatusRead (pDrvCtrl);             /* dummy code */
    if ((stat & (DM6000_TINT|DM6000_TFULL)) == 0)
        return ((STATUS) EAGAIN);

    /* TODO - Process the net buffer into a device transmit packet */

    /* TODO - transmit packet */
    len = netMblkToBufCopy (pMblk, (char*)(pDrvCtrl->txBuf), NULL);
    len = max (len, ETHERSMALL);
    skb.len = len;
    skb.pData = (char*)pDrvCtrl->txBuf;

    oldv = intLock();
    dmfe_start_xmit( &skb, pDrvCtrl );
    intUnlock( oldv );

    /* Bump the statistic counter. */

    END_ERR_ADD (&pDrvCtrl->end, MIB2_OUT_UCAST, +1);

    /* Free the data if it was accepted by device */

    netMblkClFree (pMblk);

    DRV_LOG (DRV_DEBUG_POLL_TX, "leaving dm6000PollSend", 1, 2, 3, 4, 5, 6);

    return (OK);
}

/*****************************************************************************
*
* dm6000MCastAdd - add a multicast address for the device
*
* This routine adds a multicast address to whatever the driver
* is already listening for.  It then resets the address filter.
*
* RETURNS: OK or ERROR.
*/

static STATUS dm6000MCastAdd( END_DEVICE *pDrvCtrl,      /* device pointer */
                             char* pAddress )           /* new address to add */
{
    int error;
    int oldv=intLock();
    DRV_LOG (DRV_DEBUG_LOAD, "dm6000MCastAdd()", 1, 2, 3, 4, 5, 6);

    if (etherMultiAdd (&pDrvCtrl->end.multiList,
        pAddress) == ENETRESET)
    {
        dm6000AddrFilterSet (pDrvCtrl);
        dm6000_hash_table( pDrvCtrl ); 
    }
    intUnlock(oldv);
    return (OK);
}

/*****************************************************************************
*
* dm6000MCastDel - delete a multicast address for the device
*
* This routine removes a multicast address from whatever the driver
* is listening for.  It then resets the address filter.
*
* RETURNS: OK or ERROR.
*/

static STATUS dm6000MCastDel( END_DEVICE *pDrvCtrl,  /* device pointer */
                             char *pAddress )       /* address to be deleted */
{
    int error;
    int oldv=intLock();
    DRV_LOG (DRV_DEBUG_LOAD, "dm6000MCastDel()", 1, 2, 3, 4, 5, 6);

    if (etherMultiDel (&pDrvCtrl->end.multiList,
         (char *)pAddress) == ENETRESET)
    {
        dm6000AddrFilterSet (pDrvCtrl);
        dm6000_hash_table( pDrvCtrl );
    }
   intUnlock(oldv);
    return (OK);
}

/*****************************************************************************
*
* dm6000MCastGet - get the multicast address list for the device
*
* This routine gets the multicast list of whatever the driver
* is already listening for.
*
* RETURNS: OK or ERROR.
*/

static STATUS dm6000MCastGet( END_DEVICE *pDrvCtrl,  /* device pointer */
                             MULTI_TABLE *pTable )  /* address table to be filled in */
{
    DRV_LOG (DRV_DEBUG_LOAD, "dm6000MCastGet()", 1, 2, 3, 4, 5, 6);

    return (etherMultiGet (&pDrvCtrl->end.multiList, pTable));
}

/*******************************************************************************
*
* dm6000Stop - stop the device
*
* This function calls BSP functions to disconnect interrupts and stop
* the device from operating in interrupt mode.
*
* RETURNS: OK or ERROR.
*/

static STATUS dm6000Stop( END_DEVICE *pDrvCtrl )     /* device to be stopped */
{
    STATUS result = OK;

    DRV_LOG (DRV_DEBUG_LOAD, "dm6000Stop()", 1, 2, 3, 4, 5, 6);

    /* TODO - stop/disable the device. */
    dmfe_stop_dm6000( pDrvCtrl );

    /*sysEndIsrLink.arg = (int)pDrvCtrl;*/
    SYS_INT_DISCONNECT (pDrvCtrl, dm6000Int, &result);

    if (result == ERROR)
    {
        DRV_LOG (DRV_DEBUG_STATUS, "Could not disconnect interrupt!",
            1, 2, 3, 4, 5, 6);
    }

    return (result);
}

/******************************************************************************
*
* dm6000Unload - unload a driver from the system
*
* This function first brings down the device, and then frees any
* stuff that was allocated by the driver in the load function.
*
* RETURNS: OK or ERROR.
*/

static STATUS dm6000Unload( END_DEVICE *pDrvCtrl )   /* device to be unloaded */
{
    DRV_LOG (DRV_DEBUG_NO, "dm6000Unload()", 1, 2, 3, 4, 5, 6);

    END_OBJECT_UNLOAD (&pDrvCtrl->end);

    /* TODO - Free any shared DMA memory */

    return (OK);
}

/*******************************************************************************
*
* dm6000PollStart - start polled mode operations
*
* RETURNS: OK or ERROR.
*/

static STATUS dm6000PollStart( END_DEVICE *pDrvCtrl )    /* device to be polled */
{
    int         oldLevel;

    DRV_LOG (DRV_DEBUG_LOAD, "dm6000PollStart()", 1, 2, 3, 4, 5, 6);
    oldLevel = intLock ();          /* disable ints during update */

    /* TODO - turn off interrupts */

    (pDrvCtrl->flags) |= DM6000_POLLING;

    dm6000Reset( pDrvCtrl );
    dm6000Config( pDrvCtrl );       /* reconfigure device */

    intUnlock (oldLevel);   /* now dm6000Int won't get confused */

    DRV_LOG (DRV_DEBUG_POLL, "STARTED", 1, 2, 3, 4, 5, 6);


    return (OK);
}

/*******************************************************************************
*
* dm6000PollStop - stop polled mode operations
*
* This function terminates polled mode operation.  The device returns to
* interrupt mode.
*
* The device interrupts are enabled, the current mode flag is switched
* to indicate interrupt mode and the device is then reconfigured for
* interrupt operation.
*
* RETURNS: OK or ERROR.
*/

static STATUS dm6000PollStop( END_DEVICE *pDrvCtrl ) /* device to be polled */
{
    int         oldLevel;

    DRV_LOG (DRV_DEBUG_LOAD, "dm6000PollStop()", 1, 2, 3, 4, 5, 6);

    oldLevel = intLock ();  /* disable ints during register updates */

    /* TODO - re-enable interrupts */

    (pDrvCtrl->flags) &= ~DM6000_POLLING;

    dm6000Reset( pDrvCtrl );
    dm6000Config( pDrvCtrl );       /* reconfigure device */

    intUnlock (oldLevel);

    DRV_LOG (DRV_DEBUG_POLL, "STOPPED", 1, 2, 3, 4, 5, 6);

    return (OK);
}

/*******************************************************************************
*
* dm6000Reset - reset device
*
* RETURNS: N/A.
*/

static void dm6000Reset( END_DEVICE *pDrvCtrl )
{
    /* TODO - reset the controller */
    DRV_LOG (DRV_DEBUG_LOAD, "dm6000Reset()", 1, 2, 3, 4, 5, 6);
    dmfe_reset_dm6000( pDrvCtrl );
}

/*******************************************************************************
*
* dm6000StatusRead - get current device state/status
*
* RETURNS: status bits.
*/

static UINT dm6000StatusRead( END_DEVICE *pDrvCtrl )
{
    /* TODO - read and return status bits/register */
    UINT retv = 0;
    UCHAR status = 0;
    UCHAR rxbyte = 0;

    DM6000_IN_CHAR( 0xfe, status );
    DM6000_IN_CHAR( 0xf0, rxbyte ); /* Dummy read */
    DM6000_IN_CHAR( 0xf0, rxbyte ); /* Got most updated data */

    if( !((pDrvCtrl->flags) & DM6000_POLLING) )       
        retv |= DM6000_RXON;

    if( status & 0x01 )
        retv |= DM6000_RINT;

    if( status & 0x02 )
        retv |= DM6000_TINT;

    if( pDrvCtrl->tx_pkt_cnt > 1 )                  
        retv |= DM6000_TFULL;

    if( rxbyte == DM6000_PKT_RDY )
        retv |= DM6000_RXRDY;
    return (retv);
}

static void dmfe_reset_dm6000( END_DEVICE *dev )
{
    char status = 1;
    UWORD enaddr;
    UCHAR tmp;

    DRV_LOG (DRV_DEBUG_LOAD, "dmfe_reset_dm6000()", 1, 2, 3, 4, 5, 6);
    DM6000_OUT_CHAR( 0x0, 1 );              
    while( (status & 1) )                   
    {
        udelay(100);
        DM6000_IN_CHAR( 0x0, status );
    }
    
    enaddr = read_srom_word( dev, 0 );
    dev->enetAddr[0] = (UCHAR)(enaddr);
    dev->enetAddr[1] = (UCHAR)(enaddr>>8);
    enaddr = read_srom_word( dev, 1 );
    dev->enetAddr[2] = (UCHAR)(enaddr);
    dev->enetAddr[3] = (UCHAR)(enaddr>>8);
    enaddr = read_srom_word( dev, 2 );
    dev->enetAddr[4] = (UCHAR)(enaddr);
    dev->enetAddr[5] = (UCHAR)(enaddr>>8);


    DRV_LOG (DRV_DEBUG_LOAD, "netAddress",
            dev->enetAddr[0],
            dev->enetAddr[1],
            dev->enetAddr[2],
            dev->enetAddr[3],
            dev->enetAddr[4],
            dev->enetAddr[5] );

    /* I/O mode */
    DM6000_IN_CHAR( 0xfe, tmp );
    dev->io_mode = (tmp&0xff) >> 6;        /* ISR bit7:6 keeps I/O mode */

    /* NIC Type: FASTETHER, HOMERUN, LONGRUN */
    identify_nic( dev );

    /* Set PHY */
    set_PHY_mode( dev );

    /* Init needed register value */
    dev->reg0 = DM6000_REG00;
    if ( (dev->nic_type != FASTETHER_NIC) && (dev->op_mode & DM6000_1M_HPNA) )
        dev->reg0 |= DM6000_EXT_MII;

    DM6000_OUT_CHAR( 0x05, DM6000_REG05 );      /* RX disable */
    DM6000_OUT_CHAR( 0xff, 80 );                /* disable TX/RX interrupt mask */

}


static void dmfe_config_dm6000( END_DEVICE *dev, int oo)
{
    DRV_LOG (DRV_DEBUG_LOAD, "dmfe_config_dm6000()", 1, 2, 3, 4, 5, 6);

    /* Program operating register */
    DM6000_OUT_CHAR( 0xff, 0x80 );      /* Enable TX/RX interrupt mask */
    DM6000_OUT_CHAR( 0x00, dev->reg0 );
    DM6000_OUT_CHAR( 0x02, 0 );             /* TX Polling clear */
    DM6000_OUT_CHAR( 0x08, DM6000_REG08 );  /* Less 3Kb, 200us */
    DM6000_OUT_CHAR( 0x09, DM6000_REG09 ); /* Flow Control : High/Low Water */
    DM6000_OUT_CHAR( 0x0a, DM6000_REG0A ); /* Flow Control */
    DM6000_OUT_CHAR( 0x2f, 0 );         /* Special Mode */
    DM6000_OUT_CHAR( 0x01, 0x2c);       /* clear TX status */
    DM6000_OUT_CHAR( 0xfe, 0x0f);       /* Clear interrupt status */

    /* Set address filter table */
    /* Set Physical Address Register */
    /* Set Multicast Address Register */
    dm6000_hash_table( dev );

    if( oo == 2 )
    {
        /* Activate DM6000 */
        DM6000_OUT_CHAR( 0x05, DM6000_REG05 | 1 );  /* RX enable */
        DM6000_OUT_CHAR( 0xff, DM6000_REGFF );      /* Enable TX/RX interrupt mask */
    }
    if( oo == 1 )
    {
        /* Activate DM6000 */
        DM6000_OUT_CHAR( 0x05, DM6000_REG05 );      /* RX disable */
        DM6000_OUT_CHAR( 0xff, 80 );                /* disable TX/RX interrupt mask */
    }

    /* Init Driver variable */
    dev->tx_pkt_cnt = 0;
    dev->device_wait_reset = 0;

    udelay(500);
}

/* Hardware start transmission.
   Send a packet to media from the upper layer.
*/
static int dmfe_start_xmit( PKT *skb, END_DEVICE *dev)
{ 
    char *data_ptr;
    int i, oldv;
    unsigned char imr=0;
    int tmplen;
    UWORD  tmpdata;
    UCHAR  regsave;

    DRV_LOG (DRV_DEBUG_TX, "dmfe_start_xmit()", 1, 2, 3, 4, 5, 6);

    DRV_SP( DRV_PK,"." );

    DM6000_IN_CHAR( 0x01, tmpdata );
    if( !(tmpdata & 0x40) )
    {
        DRV_LOG (DRV_DEBUG_STATUS,"tx need reset", 1, 2, 3, 4, 5, 6);
        dm6000Reset( dev );
        dm6000Config( dev );
        return 3;
    }
	/*DM6000_IN_CHAR(0xff,imr);
	printf("imr= %x",imr);
	DM6000_IN_CHAR(0xfe,imr);
	printf("imr= %x",imr);*/
    if( (skb->len == 0) || (skb->pData == NULL) )
    {
        DRV_LOG (DRV_DEBUG_STATUS,"len == 0 || pData == NULL", 1, 2, 3, 4, 5, 6);
        return 2;
    }

    /* Resource flag check */
    if( dev->tx_pkt_cnt > 1)
    {
        DRV_LOG (DRV_DEBUG_STATUS,"tx full", dev->tx_pkt_cnt, 2, 3, 4, 5, 6);
        DM6000_IN_CHAR( 2, regsave );
        return 1;
    }

    /* Disable all interrupt
    DM6000_IN_CHAR( 0xff, regsave );
    DM6000_OUT_CHAR( 0xff, 0x80 ); */
	
    /* Move data to DM6000 TX RAM */
    data_ptr = (char *)skb->pData;
   /* for (i=0; i < skb->len ;i ++)
	{
		printf("%2x",data_ptr[i]);
		if (!(i%16))
			printf("\n");
	}*/
	/*printf("packet end..\n");*/
    DM6000_OUT_ADDR( 0xf8 );
    if( dev->io_mode == 2)
    {
        /* Byte mode */
        for( i = 0; i < skb->len; i++ )
            DM6000_OUT_BYTE( (data_ptr[i] & 0xff) );
    }
    else
    {
        /* Word mode */
        tmplen = (skb->len + 1) / 2;
        for( i = 0; i < tmplen; i++ )
        {
            tmpdata = ((UWORD *)data_ptr)[i];
            DM6000_OUT_WORD( (tmpdata) );
        }
    }
    dev->queue_pkt_len = skb->len;
    dev->tx_pkt_cnt ++;

    /* TX control: First packet immediately send, second packet queue */
    if (dev->tx_pkt_cnt == 1)
    {
        /* First Packet */

        /* Set TX length to DM6000 */
        DM6000_OUT_CHAR( 0xfc, skb->len & 0xff );
        DM6000_OUT_CHAR( 0xfd, (skb->len >> 8) & 0xff);

        /* Issue TX polling command */
        DM6000_OUT_CHAR( 0x2, 0x1 );        /* Cleared after TX complete */
    }
    /* Re-enable resource check */


    /* Re-enable interrupt mask
    DM6000_OUT_CHAR( 0xff, regsave ); */
    return 0;
}
/* Received a packet and pass to upper layer
 * return 0  good
 * return 1  bad data
 * return 2  need reset
 */
static int dmfe_packet_receive( PKT *skb, END_DEVICE *dev )
{
    UCHAR tmp1,tmp2;
    UWORD tmp3;
    UCHAR rxbyte;
    UCHAR *rdptr;
    UWORD i, RxStatus, RxLen, GoodPacket, tmplen;
    int   oldv;


    DRV_LOG (DRV_DEBUG_NO, "dmfe_packet_receive()", 1, 2, 3, 4, 5, 6);
    /*oldv=INT_LOCK();*/

    /* Check packet ready or not */
    DM6000_IN_CHAR( 0xf0, rxbyte ); /* Dummy read */
    DM6000_IN_CHAR( 0xf0, rxbyte ); /* Got most updated data */

    /* Status check: this byte must be 0 or 1 */
    if( rxbyte > DM6000_PKT_RDY )
    {
        DM6000_OUT_CHAR( 0x05, 0x00);   /* Stop Device */
        DM6000_OUT_CHAR( 0xfe, 0x80);   /* Stop INT request */

        /* dev->device_wait_reset = 1; */
        
        DRV_LOG (DRV_DEBUG_RX,"rx need reset", 1, 2, 3, 4, 5, 6);
        dm6000Reset( dev );
        dm6000Config( dev );
      /*  INT_UNLOCK(oldv);*/
        return 2;
    }

    /* packet ready to receive check */
    if( rxbyte == DM6000_PKT_RDY )
    {
        /* A packet ready now  & Get status/length */
        GoodPacket = 1;
        if( dev->io_mode == 2 )
        {
            /* Byte mode */
            DM6000_IN_CHAR( 0xf2, tmp1 );
            DM6000_IN_CHAR( 0xf2, tmp2 );
            RxStatus = tmp1 + (tmp2 << 8);

            DM6000_IN_CHAR( 0xf2, tmp1 );
            DM6000_IN_CHAR( 0xf2, tmp2 );
            RxLen = tmp1 + (tmp2<<8);
        }
        else
        {
            /* Word mode */
            DM6000_OUT_ADDR( 0xf2 );
            DM6000_IN_WORD( RxStatus );
            DM6000_IN_WORD( RxLen );
          /*  RxStatus = htons( RxStatus );*/
           /* RxLen = htons( RxLen );*/
        }
        /*printf("\n");
	printf("rlen = %x\n",RxLen);*/
        /* Packet Status check */
        if( RxLen < 0x40)
        {
            DRV_LOG (DRV_DEBUG_RX, "packet too small ", 1, 2, 3, 4, 5, 6);
            GoodPacket = 0;
        }
        if( RxLen > DM6000_PKT_MAX )
        {
        /* оƬ״̬Ҫλ */
            DRV_LOG (DRV_DEBUG_RX, "packet too big need reset ", 1, 2, 3, 4, 5, 6);
            dm6000Reset( dev );
            dm6000Config( dev );
        /*    INT_UNLOCK(oldv);*/
            return 2;
        }
        if( RxStatus & 0xbf00)
        {
            GoodPacket = 0;
            /*if( RxStatus & 0x100 )   fifo error */
            /*if( RxStatus & 0x200 )   crc error */
            /*if( RxStatus & 0x8000 )  length error */
            DRV_LOG (DRV_DEBUG_RX, "packet error ", RxStatus, 2, 3, 4, 5, 6);
        }

        /* Move data from DM6000 */
        skb->len = 0;
        if( GoodPacket && (skb != NULL) )
        {   /* good packet*/
            skb->len = RxLen;
            rdptr = skb->pData;
            /* Read received packet from RX SARM */
            if (dev->io_mode == 2)
            {
                /* Byte mode */
                for( i=0; i<RxLen; i++ )
                    DM6000_IN_BYTE( rdptr[i] );
            }
            else
            {
                /* Word mode */
                tmplen = (RxLen + 1) / 2;
                for( i = 0; i < tmplen; i++ )
                {
                    DM6000_IN_WORD( tmp3 );
                    *((UWORD *)rdptr)++ = tmp3;
                }
                /*
                rdptr = skb->pData;
                if( (rdptr[0xc] == 0x08) && (rdptr[0xd] == 0x06) )
                    whz_puts("ARP\r\n");
                */
            }
            /* Pass to upper layer */
          /*  INT_UNLOCK(oldv);*/
            DRV_SP( DRV_PK,"!" );
            return 0;
        }
        else
        {   /* bad packet*/
            /* Without buffer or error packet */
            if( dev->io_mode == 2 )
            {
                /* Byte mode */
                for( i = 0; i < RxLen; i++ )
                    DM6000_IN_BYTE( tmp1 );
            }
            else
            {
                /* Word mode */
                tmplen = (RxLen + 1) / 2;
                for( i = 0; i < tmplen; i++ )
                    DM6000_IN_WORD( tmp3 );
            }
            /*INT_UNLOCK(oldv);*/
            return 1;
        }
    }
    DRV_LOG (DRV_DEBUG_RX, "no ready ", 1, 2, 3, 4, 5, 6);
    /*INT_UNLOCK(oldv);*/
    return 1;
}
/* Stop the interface.
   The interface is stopped when it is brought.
*/
static int dmfe_stop_dm6000( END_DEVICE *dev)
{

    DRV_LOG (DRV_DEBUG_LOAD, "dmfe_stop_dm6000()", 1, 2, 3, 4, 5, 6);
    /* RESET devie */
    phy_write( dev, 0x00, 0x8000 );     /* PHY RESET */
    DM6000_OUT_CHAR( 0x1f, 0x01 );      /* Power-Down PHY */
    DM6000_OUT_CHAR( 0xff, 0x80 );      /* Disable all interrupt */
    DM6000_OUT_CHAR( 0x05, 0x00 );      /* Disable RX */

    return 0;
}

/* Identify NIC type
 */
static void identify_nic( END_DEVICE *dev )
{
    UWORD phy_reg3;

    DRV_LOG (DRV_DEBUG_LOAD, "identify_nic()", 1, 2, 3, 4, 5, 6);

    DM6000_OUT_CHAR( 0, DM6000_EXT_MII );
    phy_reg3 = phy_read( dev, 3 );
    switch( phy_reg3 & 0xfff0 )
    {
        case 0xb900:
            if (phy_read(dev, 31) == 0x4404)
            {
                dev->nic_type =  HOMERUN_NIC;
                program_dm9801( dev, phy_reg3);
            }
            else
            {
                dev->nic_type = LONGRUN_NIC;
                program_dm9802(dev);
            }
            break;
        default:
            dev->nic_type = FASTETHER_NIC;
            break;
    }
    DM6000_OUT_CHAR( 0, DM6000_INT_MII );
}
/* Set PHY operationg mode
 */
static void set_PHY_mode( END_DEVICE *dev )
{
    UWORD phy_reg4 = 0x01e1, phy_reg0=0x1000;

    DRV_LOG (DRV_DEBUG_LOAD, "set_PHY_mode()", 1, 2, 3, 4, 5, 6);
    if ( !(dev->op_mode & DM6000_AUTO) )
    {
        switch(dev->op_mode)
        {
            case DM6000_10MHD:
                phy_reg4 = 0x21;
                phy_reg0 = 0x0000;
                break;
            case DM6000_10MFD:
                phy_reg4 = 0x41;
                phy_reg0 = 0x0100;
                break;
            case DM6000_100MHD:
                phy_reg4 = 0x81;
                phy_reg0 = 0x2000;
                break;
            case DM6000_100MFD:
                phy_reg4 = 0x101;
                phy_reg0 = 0x3100;   /*add by whz from 2100 */
                break;
        }
        phy_write(dev, 4, phy_reg4);    /* Set PHY media mode */
        phy_write(dev, 0, phy_reg0);    /*  Tmp */
    }
    DM6000_OUT_CHAR( 0x1e, 0x01 );      /* Let GPIO0 output */
    DM6000_OUT_CHAR( 0x1f, 0x00 );      /* Enable PHY */
}
/* Set DM6000 multicast address
 * Set DM6000 Physical Address
 */
static void dm6000_hash_table(END_DEVICE *dev)
{

    DRV_LOG (DRV_DEBUG_LOAD, "dm6000_hash_table()", 1, 2, 3, 4, 5, 6);
    /* Set Node address */
    DM6000_OUT_CHAR( 0x10, dev->enetAddr[0]);
    DM6000_OUT_CHAR( 0x11, dev->enetAddr[1]);
    DM6000_OUT_CHAR( 0x12, dev->enetAddr[2]);
    DM6000_OUT_CHAR( 0x13, dev->enetAddr[3]);
    DM6000_OUT_CHAR( 0x14, dev->enetAddr[4]);
    DM6000_OUT_CHAR( 0x15, dev->enetAddr[5]);
    DRV_LOG (DRV_DEBUG_LOAD, "netAddress",
            dev->enetAddr[0],
            dev->enetAddr[1],
            dev->enetAddr[2],
            dev->enetAddr[3],
            dev->enetAddr[4],
            dev->enetAddr[5] );
    /* Write the hash table to MAC MD table */
    DM6000_OUT_CHAR( 0x16, dev->mcastFilter[0]);
    DM6000_OUT_CHAR( 0x17, dev->mcastFilter[1]);
    DM6000_OUT_CHAR( 0x18, dev->mcastFilter[2]);
    DM6000_OUT_CHAR( 0x19, dev->mcastFilter[3]);
    DM6000_OUT_CHAR( 0x1a, dev->mcastFilter[4]);
    DM6000_OUT_CHAR( 0x1b, dev->mcastFilter[5]);
    DM6000_OUT_CHAR( 0x1c, dev->mcastFilter[6]);
    DM6000_OUT_CHAR( 0x1d, dev->mcastFilter[7]);
    DRV_LOG (DRV_DEBUG_LOAD, "netAddress",
            dev->mcastFilter[0],
            dev->mcastFilter[1],
            dev->mcastFilter[2],
            dev->mcastFilter[3],
            dev->mcastFilter[4],
            dev->mcastFilter[5] );
}

/*Init HomeRun DM9801
 */
static void program_dm9801( END_DEVICE *dev, UWORD HPNA_rev )
{
    UWORD reg16, reg17, reg24, reg25;

    DRV_LOG (DRV_DEBUG_LOAD, "program_dm9801()", 1, 2, 3, 4, 5, 6);
    if( !nfloor )
        nfloor = DM9801_NOISE_FLOOR;

    reg16 = phy_read(dev, 16);
    reg17 = phy_read(dev, 17);
    reg24 = phy_read(dev, 24);
    reg25 = phy_read(dev, 25);
    switch( HPNA_rev )
    {
        case 0xb900: /* DM9801 E3 */
            reg16 |= 0x1000;
            reg25 = ( (reg24 + nfloor) & 0x00ff) | 0xf000;
            break;
        case 0xb901: /* DM9801 E4 */
            reg25 = ( (reg24 + nfloor) & 0x00ff) | 0xc200;
            reg17 = (reg17 & 0xfff0) + nfloor + 3;
            break;
        case 0xb902: /* DM9801 E5 */
        case 0xb903: /* DM9801 E6 */
        default:
            reg16 |= 0x1000;
            reg25 = ( (reg24 + nfloor - 3) & 0x00ff) | 0xc200;
            reg17 = (reg17 & 0xfff0) + nfloor;
            break;
    }
    phy_write(dev, 16, reg16);
    phy_write(dev, 17, reg17);
    phy_write(dev, 25, reg25);
}
/*Init LongRun DM9802
 */
static void program_dm9802(END_DEVICE *dev)
{
    UWORD reg25;

    DRV_LOG (DRV_DEBUG_LOAD, "program_dm9802()", 1, 2, 3, 4, 5, 6);
    if ( !nfloor )
        nfloor = DM9802_NOISE_FLOOR;

    reg25 = phy_read(dev, 25);
    reg25 = (reg25 & 0xff00) + nfloor;
    phy_write(dev, 25, reg25);

}
/*Read a word from phyxcer
 * 
 */
static UWORD phy_read( END_DEVICE *dev, int reg )
{
    UCHAR tmp1, tmp2;

    /* Fill the phyxcer register into REG_0C */
    DM6000_OUT_CHAR( 0xc, DM6000_PHY | reg );

    DM6000_OUT_CHAR( 0xb, 0xc );        /* Issue phyxcer read command */
    do
    {
        udelay(100);                        /* Wait read complete */
        DM6000_IN_CHAR( 0xb, tmp1 );
    }while( tmp1&1 );
    DM6000_OUT_CHAR( 0xb, 0x0 );        /* Clear phyxcer read command */

    /* The read data keeps on REG_0D & REG_0E */
    DM6000_IN_CHAR( 0xe , tmp1 );
    DM6000_IN_CHAR( 0xd , tmp2 );
    return ( (tmp1 << 8 ) | tmp2 );
}
/* Write a word to phyxcer
 * 
 */
static void phy_write( END_DEVICE *dev, int reg, UWORD value)
{
    UCHAR tmp1;
    /* Fill the phyxcer register into REG_0C */
    DM6000_OUT_CHAR( 0xc, DM6000_PHY | reg );

    /* Fill the written data into REG_0D & REG_0E */
    DM6000_OUT_CHAR( 0xd, (value & 0xff) );
    DM6000_OUT_CHAR( 0xe, ( (value >> 8) & 0xff) );

    DM6000_OUT_CHAR( 0xb, 0xa );        /* Issue phyxcer write command */
    do
    {
        udelay(100);                        /* Wait read complete */
        DM6000_IN_CHAR( 0xb, tmp1 );
    }while( tmp1&1 );
    DM6000_OUT_CHAR( 0xb, 0x0 );        /* Clear phyxcer write command */
}
/* Read a word data from SROM
*/
static UWORD read_srom_word( END_DEVICE *dev, UCHAR offset)
{
    UCHAR tmp1, tmp2;

    DM6000_OUT_CHAR( 0xc, offset);

    DM6000_OUT_CHAR( 0xb, 0x4);
    do
    {
        udelay(100);                        /* Wait read complete */
        DM6000_IN_CHAR( 0xb, tmp1 );
    }while( tmp1&1 );
    DM6000_OUT_CHAR( 0xb, 0x0);

    DM6000_IN_CHAR( 0xe, tmp1 );
    DM6000_IN_CHAR( 0xd, tmp2 );

    return ( (tmp1<<8) + tmp2 );
}

static void write_srom_word( END_DEVICE *dev, UCHAR offset, UWORD value )
{
    unsigned char tmp1;

    /*DM6000_OUT_CHAR( 0xc, offset);*/
    sysOutByte(0x300,0xc);
    sysOutByte(0x304,offset);

    DM6000_OUT_CHAR( 0xd, (value & 0xff) );
    DM6000_OUT_CHAR( 0xe, ( (value >> 8) & 0xff) );

    DM6000_OUT_CHAR( 0xb, 0x12);
    do
    {
        udelay(100);                        /* Wait read complete */
        DM6000_IN_CHAR( 0xb, tmp1 );
    }while( tmp1&1 );
    DM6000_OUT_CHAR( 0xb, 0x0);
}


/* Calculate the CRC valude of the Rx packet
  flag = 1 : return the reverse CRC (for the received packet CRC)
         0 : return the normal CRC (for Hash Table index)
 */
static unsigned long cal_CRC(unsigned char * Data, unsigned int Len, UCHAR flag)
{
    unsigned long Crc = 0xffffffff;
    while (Len--)
    {
        Crc = CrcTable[(Crc ^ *Data++) & 0xFF] ^ (Crc >> 8);
    }

    if( flag )
        return ~Crc;
    else
        return Crc;
}

/* Delay N us
 */
static void udelay( int us )
{
    taskDelay(us/10);
    /*
    for( ;us > 0; us-- )
    {
        Delay500ns();
        Delay500ns();
    }*/
}
/* Delay 500 ns
 */
static void Delay500ns(void)
{
    int i;
    register int dummy;
    for(i=0;i<2;i++)
    {
        dummy=i;
    }
}




